Index: busdma_machdep-v6.c
===================================================================
--- busdma_machdep-v6.c	(revision 254221)
+++ busdma_machdep-v6.c	(working copy)
@@ -425,6 +425,8 @@
 	if (_bus_dma_can_bounce(newtag->lowaddr, newtag->highaddr)
 	 || newtag->alignment > 1)
 		newtag->flags |= BUS_DMA_COULD_BOUNCE;
+	else
+		maxsize = 2; /* Need at most 2 bounce pages for unaligned acces */
 
 	if ((flags & BUS_DMA_ALLOCNOW) != 0) {
 		struct bounce_zone *bz;
@@ -519,7 +521,10 @@
 	 * Attempt to add pages to our pool on a per-instance
 	 * basis up to a sane limit.
 	 */
-	maxpages = MAX_BPAGES;
+	if (dmat->flags & BUS_DMA_COULD_BOUNCE)
+		maxpages = MAX_BPAGES;
+	else
+		maxpages = 2 * bz->map_count; /* Only need at most 2 pages for unaligned access */
 	if ((dmat->flags & BUS_DMA_MIN_ALLOC_COMP) == 0
 	    || (bz->map_count > 0 && bz->total_bpages < maxpages)) {
 		int pages;
